import com.qcloud.dts.context.SubscribeContext;
import com.qcloud.dts.message.ClusterMessage;
import com.qcloud.dts.message.DataMessage;
import com.qcloud.dts.subscribe.ClusterListener;
import com.qcloud.dts.subscribe.DefaultSubscribeClient;
import org.apache.log4j.Logger;

import java.io.FileOutputStream;
import java.io.OutputStream;
import java.util.List;


/**
 * 将指定库上的订阅记录，写到一个文件中
 */
public class LocalDemo {
    private static Logger logger = Logger.getLogger(LocalDemo.class);


    public static void main(String[] args) throws Exception {


        SubscribeContext context = new SubscribeContext();
	// 从云API获取密钥,填写到此处
        context.setSecretId("AKIDthKl1testYR9gGEgztes");
        context.setSecretKey("udBd4PZkttestQkytest1432RkeT");
	// 在数据迁移服务里面通过数据订阅获取到对应的ip,port,填写到此处
        context.setServiceIp("10.66.112.186");
        context.setServicePort(7507);
        final DefaultSubscribeClient client = new DefaultSubscribeClient(context);
	// 填写对应要同步的数据库和表名,并修改对应要落地存储的文件名.
        final String targetDatabase = "test";
        final String targetTable = "alantest";

        final String fileName = "test.alan.txt";
        final OutputStream outputStream = new FileOutputStream(fileName,true);


        ClusterListener listener = new ClusterListener() {
            @Override
            public void notify(List<ClusterMessage> messages) throws Exception {

                for(ClusterMessage m:messages){
                    DataMessage.Record record = m.getRecord();
		    //		    System.out.println("In :\n" + record);
                    if(!record.getDbName().equalsIgnoreCase(targetDatabase) || !record.getTablename().equalsIgnoreCase(targetTable)){
			//			System.out.println("-----ok");
                        m.ackAsConsumed();
                        continue;
                    }

                    outputStream.write(record.toString().getBytes());
		    
		    // 开启下面的确认ack,就不会重复再拉取,如果希望能继续拉取之前未确认的，可以注释掉下面这行ack.
                    m.ackAsConsumed();
                }
            }
            @Override
            public void onException(Exception e){
                System.out.println("listen exception" + e);
            }
	    };

        client.addClusterListener(listener);
	// 通过数据迁移订阅的配置选项获取到dts-channel的配置信息,填写到此处.
	    client.askForGUID("dts-channel-e4FQxtYV3It41mA1");
        client.start();
    }
}
